## lib60870 2.3.2

=== lib60870-C/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

# automagically detect if we should cross-compile
if(DEFINED ENV{TOOLCHAIN})
	set(CMAKE_C_COMPILER	$ENV{TOOLCHAIN}gcc)
	set(CMAKE_CXX_COMPILER	$ENV{TOOLCHAIN}g++)
	set(CMAKE_AR	"$ENV{TOOLCHAIN}ar" CACHE FILEPATH "CW archiver" FORCE)
endif()

project(lib60870-C)
ENABLE_TESTING()

set(LIB_VERSION_MAJOR "2")
set(LIB_VERSION_MINOR "3")
set(LIB_VERSION_PATCH "2")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/third_party/cmake/modules/")

macro(ADD_C_FLAGS flags)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flags}")
endmacro()

# feature checks
include(CheckLibraryExists)
check_library_exists(rt clock_gettime "time.h" CONFIG_SYSTEM_HAS_CLOCK_GETTIME)

# check if we are on a little or a big endian
include (TestBigEndian)
test_big_endian(PLATFORM_IS_BIGENDIAN)

option(BUILD_HAL "Build the platform abstraction layer (HAL)" ON)
option(BUILD_COMMON "Build common code (shared with other libraries - e.g. libiec61850)" ON)

option(BUILD_EXAMPLES "Build the examples" ON)
option(BUILD_TESTS "Build the tests" ON)

if(BUILD_HAL)

if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)
set(WITH_MBEDTLS 1)
else()
message("NOTE: mbedtls 2.28 is required for TLS support!")
endif(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)

endif(BUILD_HAL)

include_directories(
    ${CMAKE_CURRENT_LIST_DIR}/config
    ${CMAKE_CURRENT_LIST_DIR}/src/file-service
    ${CMAKE_CURRENT_LIST_DIR}/src/inc/api
    ${CMAKE_CURRENT_LIST_DIR}/src/inc/internal
    ${CMAKE_CURRENT_LIST_DIR}/src/common/inc
    ${CMAKE_CURRENT_LIST_DIR}/src/hal/inc
)

if(WITH_MBEDTLS)
include_directories(
    ${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls
    ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28/include
)

file(GLOB tls_SRCS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28/library/*.c)

add_definitions(-DCONFIG_CS104_SUPPORT_TLS=1)
add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")

endif(WITH_MBEDTLS)


set(API_HEADERS 
	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_time.h 
	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_thread.h
	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_socket.h
	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_serial.h
	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_base.h
	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/tls_config.h
	${CMAKE_CURRENT_LIST_DIR}/src/common/inc/linked_list.h
	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs101_master.h
	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs101_slave.h
	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs104_slave.h
	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/iec60870_master.h
	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/iec60870_slave.h
	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/iec60870_common.h
	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs101_information_objects.h
	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs104_connection.h
	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/link_layer_parameters.h
)

include(CheckCCompilerFlag)

check_c_compiler_flag("-Wredundant-decls" SUPPORT_REDUNDANT_DECLS)
if (SUPPORT_REDUNDANT_DECLS)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wredundant-decls")
endif(SUPPORT_REDUNDANT_DECLS)

# write the detected stuff to this file
# configure_file(config/lib60870_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config/lib60870_config.h)

if(BUILD_EXAMPLES)
	add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/examples)
endif(BUILD_EXAMPLES)

if(BUILD_TESTS)
	add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/tests)
endif(BUILD_TESTS)

add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/src)

INSTALL(FILES ${API_HEADERS} DESTINATION include/lib60870 COMPONENT Development)

IF(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake")
INCLUDE(InstallRequiredSystemLibraries)
 
SET(CPACK_PACKAGE_DESCRIPTION "IEC 60870-5-101/104 master/slave library")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "IEC 60870-5-101/104 master/slave library")
SET(CPACK_PACKAGE_VENDOR "MZ Automation GmbH")
SET(CPACK_PACKAGE_CONTACT "info@mz-automation.de")
SET(CPACK_PACKAGE_VERSION_MAJOR "${LIB_VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${LIB_VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${LIB_VERSION_PATCH}")
SET(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${LIB_VERSION_MAJOR}.${LIB_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}_${CMAKE_SYSTEM_PROCESSOR}")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${LIB_VERSION_MAJOR}.${LIB_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 
SET(CPACK_COMPONENTS_ALL Libraries Development Applications)
#set(CPACK_PACKAGE_INSTALL_DIRECTORY "${CMAKE_PROJECT_NAME}")
INCLUDE(CPack)
 
ENDIF(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake")

=== lib60870-C/Makefile ===
LIB60870_HOME=.

include make/target_system.mk

ifndef WITHOUT_COMMON

LIB_SOURCE_DIRS = src/common

endif

LIB_SOURCE_DIRS += src/iec60870
LIB_SOURCE_DIRS += src/iec60870/cs101
LIB_SOURCE_DIRS += src/iec60870/cs104
LIB_SOURCE_DIRS += src/iec60870/link_layer
LIB_SOURCE_DIRS += src/iec60870/apl

ifndef WITHOUT_HAL

ifeq ($(HAL_IMPL), WIN32)
LIB_SOURCE_DIRS += src/hal/socket/win32
LIB_SOURCE_DIRS += src/hal/thread/win32
LIB_SOURCE_DIRS += src/hal/time/win32
LIB_SOURCE_DIRS += src/hal/memory
else ifeq ($(HAL_IMPL), POSIX)
LIB_SOURCE_DIRS += src/hal/socket/linux
LIB_SOURCE_DIRS += src/hal/thread/linux
LIB_SOURCE_DIRS += src/hal/time/unix
LIB_SOURCE_DIRS += src/hal/serial/linux
LIB_SOURCE_DIRS += src/hal/memory
else ifeq ($(HAL_IMPL), BSD)
LIB_SOURCE_DIRS += src/hal/socket/bsd
LIB_SOURCE_DIRS += src/hal/thread/bsd
LIB_SOURCE_DIRS += src/hal/time/unix
LIB_SOURCE_DIRS += src/hal/memory
endif

ifdef WITH_MBEDTLS
LIB_SOURCE_DIRS += dependencies/mbedtls-2.28/library
LIB_SOURCE_DIRS += src/hal/tls/mbedtls
LIB_INCLUDE_DIRS += src/hal/tls/mbedtls
LIB_INCLUDE_DIRS += dependencies/mbedtls-2.28/include
CFLAGS += -D'MBEDTLS_CONFIG_FILE="mbedtls_config.h"'
CFLAGS += -D'CONFIG_CS104_SUPPORT_TLS=1'
endif

endif

LIB_INCLUDE_DIRS += config
LIB_INCLUDE_DIRS += src/inc/api
LIB_INCLUDE_DIRS += src/inc/internal
LIB_INCLUDE_DIRS += src/hal/inc
LIB_INCLUDE_DIRS += src/common/inc


LIB_INCLUDES = $(addprefix -I,$(LIB_INCLUDE_DIRS))

ifndef INSTALL_PREFIX
INSTALL_PREFIX = ./.install
endif

LIB_API_HEADER_FILES = src/hal/inc/hal_time.h 
LIB_API_HEADER_FILES += src/hal/inc/hal_thread.h
LIB_API_HEADER_FILES += src/hal/inc/hal_socket.h
LIB_API_HEADER_FILES += src/hal/inc/hal_serial.h
LIB_API_HEADER_FILES += src/hal/inc/hal_base.h
LIB_API_HEADER_FILES += src/common/inc/linked_list.h
LIB_API_HEADER_FILES += src/inc/api/cs101_information_objects.h
LIB_API_HEADER_FILES += src/inc/api/cs101_master.h
LIB_API_HEADER_FILES += src/inc/api/cs101_slave.h
LIB_API_HEADER_FILES += src/inc/api/cs104_connection.h
LIB_API_HEADER_FILES += src/inc/api/cs104_slave.h
LIB_API_HEADER_FILES += src/inc/api/iec60870_common.h
LIB_API_HEADER_FILES += src/inc/api/iec60870_master.h
LIB_API_HEADER_FILES += src/inc/api/iec60870_slave.h
LIB_API_HEADER_FILES += src/inc/api/link_layer_parameters.h
LIB_API_HEADER_FILES += src/hal/inc/tls_config.h

LIB_TEST_SOURCES = tests/all_tests.c
LIB_TEST_SOURCES += tests/unity/unity.c

LIB_TEST_INCLUDE_DIRS = tests/unity

TEST_INCLUDES = $(addprefix -I,$(LIB_TEST_INCLUDE_DIRS))

get_sources_from_directory  = $(wildcard $1/*.c)
get_sources = $(foreach dir, $1, $(call get_sources_from_directory,$(dir)))
src_to = $(addprefix $(LIB_OBJS_DIR)/,$(subst .c,$1,$2))

LIB_SOURCES = $(call get_sources,$(LIB_SOURCE_DIRS))

LIB_OBJS = $(call src_to,.o,$(LIB_SOURCES))
TEST_OBJS = $(call src_to,.o,$(LIB_TEST_SOURCES))
CFLAGS += -std=gnu99
#CFLAGS += -Wno-error=format 
CFLAGS += -Wstrict-prototypes -Wall -Wextra

ifneq ($(HAL_IMPL), WIN32)
CFLAGS += -Wuninitialized 
endif

CFLAGS += -Wsign-compare 
CFLAGS += -Wpointer-arith 
CFLAGS += -Wnested-externs 
CFLAGS += -Wmissing-declarations 
CFLAGS += -Wshadow
CFLAGS += -Wall
#CFLAGS += -Werror  

all:	lib

static_checks:	lib
	splint -preproc +posixlib +skip-sys-headers +gnuextensions $(LIB_INCLUDES) $(LIB_SOURCES)

cppcheck:	lib
	cppcheck --xml --force --std=c99 --enable=all $(LIB_INCLUDES) $(LIB_SOURCES) 2> cppcheck-output.xml

lib:	$(LIB_NAME)

tests:	$(TEST_NAME)

dynlib: CFLAGS += -fPIC

dynlib:	$(DYN_LIB_NAME)

.PHONY:	examples

examples:
	cd examples; $(MAKE)
	
$(TEST_NAME):	$(LIB_OBJS) $(TEST_OBJS)
	$(CC) -o $(TEST_NAME) $(LIB_OBJS) $(TEST_OBJS) -lpthread

$(LIB_NAME):	$(LIB_OBJS)
	$(AR) r $(LIB_NAME) $(LIB_OBJS)
	$(RANLIB) $(LIB_NAME)
	
$(DYN_LIB_NAME):	$(LIB_OBJS)
	$(CC) $(LDFLAGS) $(DYNLIB_LDFLAGS) -shared -o $(DYN_LIB_NAME) $(LIB_OBJS) $(LDLIBS)

$(LIB_OBJS_DIR)/%.o: %.c config
	@echo compiling $(notdir $<)
	$(SILENCE)mkdir -p $(dir $@)
	$(CC) $(CFLAGS) -c $(LIB_INCLUDES) $(TEST_INCLUDES) $(OUTPUT_OPTION) $<
	
install:	$(LIB_NAME)
	mkdir -p $(INSTALL_PREFIX)/include
	mkdir -p $(INSTALL_PREFIX)/lib
	cp $(LIB_API_HEADER_FILES) $(INSTALL_PREFIX)/include
	cp $(LIB_NAME) $(INSTALL_PREFIX)/lib

clean:
	rm -f $(EXAMPLES)
	rm -rf $(LIB_OBJS_DIR)

=== lib60870-C/examples/CMakeLists.txt ===
add_subdirectory(cs101_master_balanced)
add_subdirectory(cs101_master_unbalanced)
add_subdirectory(cs101_slave)
add_subdirectory(cs101_slave_files)
add_subdirectory(cs104_client)
add_subdirectory(cs104_client_async)
add_subdirectory(cs104_server)
add_subdirectory(cs104_server_no_threads)
add_subdirectory(cs104_server_files)
add_subdirectory(cs104_redundancy_server)
add_subdirectory(multi_client_server)

if (WITH_MBEDTLS)
add_subdirectory(tls_client)
add_subdirectory(tls_server)
endif (WITH_MBEDTLS)

=== lib60870-C/src/CMakeLists.txt ===

set (lib_common_SRCS
./file-service/file_server.c
./iec60870/apl/cpXXtime2a.c
./iec60870/cs101/cs101_asdu.c
./iec60870/cs101/cs101_bcr.c
./iec60870/cs101/cs101_information_objects.c
./iec60870/cs101/cs101_master_connection.c
./iec60870/cs101/cs101_master.c
./iec60870/cs101/cs101_queue.c
./iec60870/cs101/cs101_slave.c
./iec60870/cs104/cs104_connection.c
./iec60870/cs104/cs104_frame.c
./iec60870/cs104/cs104_slave.c
./iec60870/link_layer/buffer_frame.c
./iec60870/link_layer/link_layer.c
./iec60870/link_layer/serial_transceiver_ft_1_2.c
./iec60870/frame.c
./iec60870/lib60870_common.c
)

if (BUILD_COMMON)
list (APPEND lib_common_SRCS ./common/linked_list.c)
endif (BUILD_COMMON)

if (BUILD_HAL)

set (lib_linux_SRCS
./hal/serial/linux/serial_port_linux.c
./hal/socket/linux/socket_linux.c
./hal/thread/linux/thread_linux.c
./hal/time/unix/time.c
./hal/memory/lib_memory.c
)

set (lib_windows_SRCS
./hal/serial/win32/serial_port_win32.c
./hal/socket/win32/socket_win32.c
./hal/thread/win32/thread_win32.c
./hal/time/win32/time.c
./hal/memory/lib_memory.c
)

set (lib_bsd_SRCS
./hal/serial/linux/serial_port_linux.c
./hal/socket/bsd/socket_bsd.c
./hal/thread/bsd/thread_bsd.c
./hal/time/unix/time.c
./hal/memory/lib_memory.c
)

set (lib_macos_SRCS
./hal/serial/linux/serial_port_linux.c
./hal/socket/bsd/socket_bsd.c
./hal/thread/macos/thread_macos.c
./hal/time/unix/time.c
./hal/memory/lib_memory.c
)

endif (BUILD_HAL)

IF(WIN32)

IF(MSVC)
set_source_files_properties(${lib_common_SRCS} ${lib_windows_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF()

set (library_SRCS
    ${lib_common_SRCS}
    ${lib_windows_SRCS}
)

set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}\"/DEF:${CMAKE_CURRENT_SOURCE_DIR}/vs/lib60870.def\"") 

ELSEIF(UNIX)
IF(APPLE)
set (library_SRCS
    ${lib_common_SRCS}
    ${lib_macos_SRCS}
)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
set (library_SRCS
    ${lib_common_SRCS}
    ${lib_bsd_SRCS}
)
ELSE()
set (library_SRCS
    ${lib_common_SRCS}
    ${lib_linux_SRCS}	
)
ENDIF(APPLE)
ENDIF(WIN32)

IF(WITH_MBEDTLS)

list (APPEND library_SRCS ${tls_SRCS})
list (APPEND library_SRCS ./hal/tls/mbedtls/tls_mbedtls.c)

add_definitions(-DLIB60870_HAS_TLS_SUPPORT=1)

ENDIF(WITH_MBEDTLS)

include (GenerateExportHeader)

set(RES_FILES "")
if ( WIN32 )
	# Adding RC resource file for adding information to the archive
	set(RES_FILES "${CMAKE_CURRENT_BINARY_DIR}/version.rc")
	message(STATUS "Generating RC file : ${RES_FILES}")
	configure_file(
			${CMAKE_CURRENT_SOURCE_DIR}/version.rc.in
			${RES_FILES}
			@ONLY)
	if( MINGW )
		set(CMAKE_RC_COMPILER_INIT windres)
		ENABLE_LANGUAGE(RC)
		SET(CMAKE_RC_COMPILE_OBJECT
		"<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
	endif(MINGW)
	set(library_SRCS ${library_SRCS} ${RES_FILES})
endif( WIN32 )

add_library (lib60870-shared SHARED ${library_SRCS} )

set_target_properties(lib60870-shared PROPERTIES
           OUTPUT_NAME lib60870
           SOVERSION "${LIB_VERSION_MAJOR}.${LIB_VERSION_MINOR}.${LIB_VERSION_PATCH}"
	   WINDOWS_EXPORT_ALL_SYMBOLS true
)


GENERATE_EXPORT_HEADER(lib60870-shared
			BASE_NAME lib60870-shared
			EXPORT_MACRO_NAME lib60870-shared_EXPORT
			EXPORT_FILE_NAME lib60870-shared_export.h
			STATIC_DEFINE lib60870-shared_BUILT_AS_STATIC
)

add_library (lib60870 STATIC ${library_SRCS})

IF(UNIX)
  IF (CONFIG_SYSTEM_HAS_CLOCK_GETTIME)
     target_link_libraries (lib60870
         -lpthread
         -lm
         -lrt
     )
  ELSE ()
     target_link_libraries (lib60870
         -lpthread
         -lm
     )
  ENDIF (CONFIG_SYSTEM_HAS_CLOCK_GETTIME)

  configure_file(
    ${CMAKE_CURRENT_LIST_DIR}/lib60870.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/lib60870.pc @ONLY
  )
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/lib60870.pc" DESTINATION "${CMAKE_INSTALL_PREFIX}/share/pkgconfig")
ENDIF(UNIX)
IF(MINGW)
  target_link_libraries(lib60870-shared ws2_32 iphlpapi)
  target_link_libraries(lib60870 ws2_32 iphlpapi)
ENDIF(MINGW)



install (TARGETS lib60870 lib60870-shared
	RUNTIME DESTINATION bin COMPONENT Applications
	ARCHIVE DESTINATION lib COMPONENT Libraries
    LIBRARY DESTINATION lib COMPONENT Libraries
)

=== lib60870-C/examples/tls_client/CMakeLists.txt ===
include_directories(
   .
)

set(example_SRCS
   tls_client.c
)

IF(WIN32)
set_source_files_properties(${example_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF(WIN32)

configure_file(client1-key.pem client1-key.pem COPYONLY)
configure_file(client1.cer client1.cer COPYONLY)
configure_file(root.cer root.cer COPYONLY)
configure_file(server.cer server.cer COPYONLY)

add_executable(tls_client
  ${example_SRCS}
)

target_link_libraries(tls_client
    lib60870
)

=== lib60870-C/src/hal/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)

# automagically detect if we should cross-compile
if(DEFINED ENV{TOOLCHAIN})
    set(CMAKE_C_COMPILER        $ENV{TOOLCHAIN}gcc)
    set(CMAKE_CXX_COMPILER      $ENV{TOOLCHAIN}g++)
    set(CMAKE_AR        "$ENV{TOOLCHAIN}ar" CACHE FILEPATH "CW archiver" FORCE)
endif()

project(hal)

set(LIBHAL_VERSION_MAJOR "2")
set(LIBHAL_VERSION_MINOR "1")
set(LIBHAL_VERSION_PATCH "0")

# feature checks
include(CheckLibraryExists)
check_library_exists(rt clock_gettime "time.h" CONFIG_SYSTEM_HAS_CLOCK_GETTIME)

# check if we are on a little or a big endian
include (TestBigEndian)
test_big_endian(PLATFORM_IS_BIGENDIAN)

if(WIN32)

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/winpcap/Lib/wpcap.lib")
message("Found winpcap -> compile ethernet HAL layer (required for GOOSE/SV support)")
set(WITH_WPCAP 1)
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../third_party/winpcap/Include")
else()
message("winpcap not found -> skip ethernet HAL layer (no GOOSE/SV support)")
endif()

endif(WIN32)

include_directories(
    ${CMAKE_CURRENT_LIST_DIR}/inc
)

set (libhal_linux_SRCS
 ${CMAKE_CURRENT_LIST_DIR}/socket/linux/socket_linux.c
 ${CMAKE_CURRENT_LIST_DIR}/ethernet/linux/ethernet_linux.c
 ${CMAKE_CURRENT_LIST_DIR}/thread/linux/thread_linux.c
 ${CMAKE_CURRENT_LIST_DIR}/filesystem/linux/file_provider_linux.c
 ${CMAKE_CURRENT_LIST_DIR}/time/unix/time.c
 ${CMAKE_CURRENT_LIST_DIR}/serial/linux/serial_port_linux.c
 ${CMAKE_CURRENT_LIST_DIR}/memory/lib_memory.c
)

set (libhal_windows_SRCS
 ${CMAKE_CURRENT_LIST_DIR}/socket/win32/socket_win32.c
 ${CMAKE_CURRENT_LIST_DIR}/thread/win32/thread_win32.c
 ${CMAKE_CURRENT_LIST_DIR}/filesystem/win32/file_provider_win32.c
 ${CMAKE_CURRENT_LIST_DIR}/time/win32/time.c
 ${CMAKE_CURRENT_LIST_DIR}/serial/win32/serial_port_win32.c
 ${CMAKE_CURRENT_LIST_DIR}/memory/lib_memory.c
)

if(WITH_WPCAP)
set (libhal_windows_SRCS ${libhal_windows_SRCS}
 ${CMAKE_CURRENT_LIST_DIR}/ethernet/win32/ethernet_win32.c
)
endif(WITH_WPCAP)

set (libhal_bsd_SRCS
 ${CMAKE_CURRENT_LIST_DIR}/socket/bsd/socket_bsd.c
 ${CMAKE_CURRENT_LIST_DIR}/ethernet/bsd/ethernet_bsd.c
 ${CMAKE_CURRENT_LIST_DIR}/thread/bsd/thread_bsd.c
 ${CMAKE_CURRENT_LIST_DIR}/filesystem/linux/file_provider_linux.c
 ${CMAKE_CURRENT_LIST_DIR}/time/unix/time.c
 ${CMAKE_CURRENT_LIST_DIR}/memory/lib_memory.c
)

set (libhal_macos_SRCS
 ${CMAKE_CURRENT_LIST_DIR}/socket/bsd/socket_bsd.c
 ${CMAKE_CURRENT_LIST_DIR}/ethernet/bsd/ethernet_bsd.c
 ${CMAKE_CURRENT_LIST_DIR}/thread/macos/thread_macos.c
 ${CMAKE_CURRENT_LIST_DIR}/filesystem/linux/file_provider_linux.c
 ${CMAKE_CURRENT_LIST_DIR}/time/unix/time.c
 ${CMAKE_CURRENT_LIST_DIR}/memory/lib_memory.c
)

IF(WIN32)

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/winpcap/Lib/wpcap.lib")
message("Found winpcap -> can compile with GOOSE support")
set(WITH_WPCAP 1)
endif()

set (libhal_SRCS
    ${libhal_windows_SRCS}
)

IF(MSVC)
set_source_files_properties(${libhal_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF()

ELSEIF(UNIX)
IF(APPLE)
set (libhal_SRCS
    ${libhal_macos_SRCS}
)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
set (libhal_SRCS
    ${libhal_bsd_SRCS}
)
ELSE()
set (libhal_SRCS
    ${libhal_linux_SRCS}
)
ENDIF(APPLE)
ENDIF(WIN32)

#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC" )
#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC" )

if(WITH_MBEDTLS)
message("Found mbedtls -> can compile HAL with TLS support")
set(WITH_MBEDTLS 1)
endif(WITH_MBEDTLS)

if(WITH_MBEDTLS)
include_directories(
	${CMAKE_CURRENT_LIST_DIR}/tls/mbedtls
    ${MBEDTLS_INCLUDE_DIR}
)

if(CONFIG_USE_EXTERNAL_MBEDTLS_DYNLIB)
link_directories(${CONFIG_EXTERNAL_MBEDTLS_DYNLIB_PATH})
else()
file(GLOB tls_SRCS ${CMAKE_CURRENT_LIST_DIR}/../third_party/mbedtls/mbedtls-2.28/library/*.c)
endif(CONFIG_USE_EXTERNAL_MBEDTLS_DYNLIB)

add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")

set (libhal_SRCS ${libhal_SRCS}
  ${CMAKE_CURRENT_LIST_DIR}/tls/mbedtls/tls_mbedtls.c
)

IF(MSVC)
set_source_files_properties(${libhal_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF()

list (APPEND libhal_SRCS ${tls_SRCS})

endif(WITH_MBEDTLS)

add_library (hal STATIC ${libhal_SRCS})

add_library (hal-shared STATIC ${libhal_SRCS})

target_compile_definitions(hal-shared PRIVATE EXPORT_FUNCTIONS_FOR_DLL)

SET_TARGET_PROPERTIES(hal-shared PROPERTIES
  COMPILE_FLAGS "-fPIC"
)

IF(UNIX)
  IF (CONFIG_SYSTEM_HAS_CLOCK_GETTIME)
     target_link_libraries (hal
         -lpthread
         -lrt
     )
  ELSE ()
     target_link_libraries (hal
         -lpthread
     )
  ENDIF (CONFIG_SYSTEM_HAS_CLOCK_GETTIME)
ENDIF(UNIX)

IF(CONFIG_USE_EXTERNAL_MBEDTLS_DYNLIB)
  target_link_libraries(hal mbedcrypto mbedx509 mbedtls)
ENDIF(CONFIG_USE_EXTERNAL_MBEDTLS_DYNLIB)

IF(MINGW)
  target_link_libraries(hal ws2_32 iphlpapi)
ENDIF(MINGW)

iF(WITH_WPCAP)
target_link_libraries(hal
	${CMAKE_CURRENT_SOURCE_DIR}/../third_party/winpcap/Lib/wpcap.lib
	${CMAKE_CURRENT_SOURCE_DIR}/../third_party/winpcap/Lib/packet.lib
)
ENDIF(WITH_WPCAP)

set(BINDIR "bin")
set(LIBDIR "lib")
if(UNIX)
    # GNUInstallDirs is required for Debian multiarch
    include(GNUInstallDirs)
    set(LIBDIR ${CMAKE_INSTALL_LIBDIR})
    set(BINDIR ${CMAKE_INSTALL_BINDIR})
endif()

install (TARGETS hal hal-shared
	RUNTIME DESTINATION ${BINDIR} COMPONENT Applications
	ARCHIVE DESTINATION ${LIBDIR} COMPONENT Libraries
    LIBRARY DESTINATION ${LIBDIR} COMPONENT Libraries
)

=== debian/changelog ===
lib60870 (2.3.2-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Drop optional TLS support (Closes: #1075864)

 -- Bastian Germann <bage@debian.org>  Wed, 13 Nov 2024 20:58:04 +0000

lib60870 (2.3.2-1) unstable; urgency=medium

  * Initial release (Closes: #1041565)

 -- Yangfl <mmyangfl@gmail.com>  Wed, 14 Feb 2024 15:50:12 +0800

=== debian/control ===
Source: lib60870
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Section: libs
Homepage: https://www.mz-automation.de/iec60870-5-101-104-c-source-code-library/
Vcs-Git: https://salsa.debian.org/yangfl-guest/lib60870.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/lib60870

Package: liblib60870-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblib60870-2 (= ${binary:Version}), ${misc:Depends}
Description: library for IEC 60870-5 based protocols in C (development files)
 lib60870 is a feature rich and field proven implementation of the IEC
 60870-5-101/104 protocol for client (master station) and server (slave or
 controlled station). The library implements all data types of the IEC
 60870-5-101/104 specifications.
 .
 This package contains the header files for lib608701.

Package: liblib60870-2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for IEC 60870-5 based protocols in C
 lib60870 is a feature rich and field proven implementation of the IEC
 60870-5-101/104 protocol for client (master station) and server (slave or
 controlled station). The library implements all data types of the IEC
 60870-5-101/104 specifications.
 .
 Features:
   * support for all application layer message types
   * master and slave
   * balanced and unbalanced link layers (for CS 101 serial communication)
   * client/server for CS 104 TCP/IP communication
   * CS 104 redundancy group support
   * CS101 slave/CS104 server: file service support
   * Supports most TLS features required by IEC 62351-3 (third party code
     mbedtls required)
   * portable C99 code

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =


%:
	dh $@ --buildsystem=cmake --sourcedirectory=lib60870-C

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_MBEDTLS=OFF

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%lib60870-$1.tar.gz%" \
   https://github.com/mz-automation/lib60870/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## lib60870 2.3.4

=== lib60870-C/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 set(LIB_VERSION_MAJOR "2")
 set(LIB_VERSION_MINOR "3")
-set(LIB_VERSION_PATCH "2")
+set(LIB_VERSION_PATCH "4")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/third_party/cmake/modules/")
 
@@ -22,7 +22,6 @@
 
 # feature checks
 include(CheckLibraryExists)
-check_library_exists(rt clock_gettime "time.h" CONFIG_SYSTEM_HAS_CLOCK_GETTIME)
 
 # check if we are on a little or a big endian
 include (TestBigEndian)
@@ -38,8 +37,12 @@
 
 if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)
 set(WITH_MBEDTLS 1)
+message("mbedtls 2.28 found")
+ELSEIF(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6)
+set(WITH_MBEDTLS3 1)
+message("mbedtls 3.6 found")
 else()
-message("NOTE: mbedtls 2.28 is required for TLS support!")
+message("NOTE: mbedtls 2.28 or 3.6 is required for TLS support!")
 endif(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)
 
 endif(BUILD_HAL)
@@ -66,6 +69,19 @@
 
 endif(WITH_MBEDTLS)
 
+if(WITH_MBEDTLS3)
+include_directories(
+	${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls3
+	${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6/include
+)
+
+file(GLOB tls_SRCS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6/library/*.c)
+
+add_definitions(-DCONFIG_CS104_SUPPORT_TLS=1)
+add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")
+
+endif(WITH_MBEDTLS3)
+
 
 set(API_HEADERS 
 	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_time.h 
@@ -74,6 +90,7 @@
 	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_serial.h
 	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_base.h
 	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/tls_config.h
+	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/tls_ciphers.h
 	${CMAKE_CURRENT_LIST_DIR}/src/common/inc/linked_list.h
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs101_master.h
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs101_slave.h
@@ -84,6 +101,7 @@
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs101_information_objects.h
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs104_connection.h
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/link_layer_parameters.h
+	${CMAKE_CURRENT_LIST_DIR}/src/file-service/cs101_file_service.h
 )
 
 include(CheckCCompilerFlag)

=== lib60870-C/examples/CMakeLists.txt ===
--- 
+++ 
@@ -10,8 +10,8 @@
 add_subdirectory(cs104_redundancy_server)
 add_subdirectory(multi_client_server)
 
-if (WITH_MBEDTLS)
+if (WITH_MBEDTLS OR WITH_MBEDTLS3)
 add_subdirectory(tls_client)
 add_subdirectory(tls_server)
-endif (WITH_MBEDTLS)
+endif (WITH_MBEDTLS OR WITH_MBEDTLS3)

=== lib60870-C/examples/cs101_slave_files/Makefile ===
LIB60870_HOME=../..

PROJECT_BINARY_NAME = cs101_slave_files
PROJECT_SOURCES = cs101_slave_files.c

include $(LIB60870_HOME)/make/target_system.mk
include $(LIB60870_HOME)/make/stack_includes.mk

all:	$(PROJECT_BINARY_NAME)

include $(LIB60870_HOME)/make/common_targets.mk


$(PROJECT_BINARY_NAME):	$(PROJECT_SOURCES) $(LIB_NAME)
	$(CC) $(CFLAGS) $(LDFLAGS) -g -o $(PROJECT_BINARY_NAME) $(PROJECT_SOURCES) $(INCLUDES) $(LIB_NAME) $(LDLIBS)

clean:
	rm -f $(PROJECT_BINARY_NAME)

=== lib60870-C/examples/tls_server/CMakeLists.txt ===
include_directories(
   .
)

set(example_SRCS
   tls_server.c
)

IF(WIN32)
set_source_files_properties(${example_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF(WIN32)

configure_file(server-key.pem server-key.pem COPYONLY)
configure_file(client1.cer client1.cer COPYONLY)
configure_file(client2.cer client2.cer COPYONLY)
configure_file(root.cer root.cer COPYONLY)
configure_file(server.cer server.cer COPYONLY)

add_executable(tls_server
  ${example_SRCS}
)

target_link_libraries(tls_server
    lib60870
)

=== debian/changelog ===
lib60870 (2.3.4-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Wed, 12 Mar 2025 10:57:01 +0800

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,3 @@
 
 %:
 	dh $@ --buildsystem=cmake --sourcedirectory=lib60870-C
-
-override_dh_auto_configure:
-	dh_auto_configure -- -DWITH_MBEDTLS=OFF

## lib60870 2.3.6

=== lib60870-C/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 set(LIB_VERSION_MAJOR "2")
 set(LIB_VERSION_MINOR "3")
-set(LIB_VERSION_PATCH "4")
+set(LIB_VERSION_PATCH "5")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/third_party/cmake/modules/")

=== lib60870-C/Makefile ===
--- 
+++ 
@@ -43,6 +43,15 @@
 CFLAGS += -D'CONFIG_CS104_SUPPORT_TLS=1'
 endif
 
+ifdef WITH_MBEDTLS3
+LIB_SOURCE_DIRS += dependencies/mbedtls-3.6/library
+LIB_SOURCE_DIRS += src/hal/tls/mbedtls3
+LIB_INCLUDE_DIRS += src/hal/tls/mbedtls3
+LIB_INCLUDE_DIRS += dependencies/mbedtls-3.6/include
+CFLAGS += -D'MBEDTLS_CONFIG_FILE="mbedtls_config.h"'
+CFLAGS += -D'CONFIG_CS104_SUPPORT_TLS=1'
+endif
+
 endif
 
 LIB_INCLUDE_DIRS += config
@@ -74,6 +83,8 @@
 LIB_API_HEADER_FILES += src/inc/api/iec60870_slave.h
 LIB_API_HEADER_FILES += src/inc/api/link_layer_parameters.h
 LIB_API_HEADER_FILES += src/hal/inc/tls_config.h
+LIB_API_HEADER_FILES += src/hal/inc/tls_ciphers.h
+LIB_API_HEADER_FILES += src/file-service/cs101_file_service.h
 
 LIB_TEST_SOURCES = tests/all_tests.c
 LIB_TEST_SOURCES += tests/unity/unity.c

=== lib60870-C/src/CMakeLists.txt ===
--- 
+++ 
@@ -101,6 +101,15 @@
 
 ENDIF(WITH_MBEDTLS)
 
+IF(WITH_MBEDTLS3)
+
+list (APPEND library_SRCS ${tls_SRCS})
+list (APPEND library_SRCS ./hal/tls/mbedtls3/tls_mbedtls.c)
+
+add_definitions(-DLIB60870_HAS_TLS_SUPPORT=1)
+
+ENDIF(WITH_MBEDTLS3)
+
 include (GenerateExportHeader)
 
 set(RES_FILES "")
@@ -140,18 +149,11 @@
 add_library (lib60870 STATIC ${library_SRCS})
 
 IF(UNIX)
-  IF (CONFIG_SYSTEM_HAS_CLOCK_GETTIME)
-     target_link_libraries (lib60870
-         -lpthread
-         -lm
-         -lrt
-     )
-  ELSE ()
-     target_link_libraries (lib60870
-         -lpthread
-         -lm
-     )
-  ENDIF (CONFIG_SYSTEM_HAS_CLOCK_GETTIME)
+    target_link_libraries (lib60870
+        -lpthread
+        -lm
+        -lrt
+    )
 
   configure_file(
     ${CMAKE_CURRENT_LIST_DIR}/lib60870.pc.in
@@ -160,11 +162,13 @@
   install(FILES "${CMAKE_CURRENT_BINARY_DIR}/lib60870.pc" DESTINATION "${CMAKE_INSTALL_PREFIX}/share/pkgconfig")
 ENDIF(UNIX)
 IF(MINGW)
-  target_link_libraries(lib60870-shared ws2_32 iphlpapi)
-  target_link_libraries(lib60870 ws2_32 iphlpapi)
+  target_link_libraries(lib60870-shared ws2_32 iphlpapi bcrypt)
+  target_link_libraries(lib60870 ws2_32 iphlpapi bcrypt)
 ENDIF(MINGW)
-
-
+IF(MSVC)
+  target_link_libraries(lib60870-shared ws2_32 iphlpapi bcrypt)
+  target_link_libraries(lib60870 ws2_32 iphlpapi bcrypt)
+ENDIF(MSVC)
 
 install (TARGETS lib60870 lib60870-shared
 	RUNTIME DESTINATION bin COMPONENT Applications

=== lib60870-C/tests/CMakeLists.txt ===
include_directories(
   ./unity
)

set(tests_SRCS
   all_tests.c
   unity/unity.c
)

IF(WIN32)
set_source_files_properties(${tests_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF(WIN32)

configure_file(server-key.pem server-key.pem COPYONLY)
configure_file(client1-key.pem client1-key.pem COPYONLY)
configure_file(client1.cer client1.cer COPYONLY)
configure_file(client2.cer client2.cer COPYONLY)
configure_file(root.cer root.cer COPYONLY)
configure_file(server.cer server.cer COPYONLY)

configure_file(certs/server_CA1_1.key server_CA1_1.key COPYONLY)
configure_file(certs/server_CA1_1.pem server_CA1_1.pem COPYONLY)
configure_file(certs/root_CA1.pem root_CA1.pem COPYONLY)

configure_file(certs/client_CA1_1.key client_CA1_1.key COPYONLY)
configure_file(certs/client_CA1_1.pem client_CA1_1.pem COPYONLY)

configure_file(certs/client_CA1_2.key client_CA1_2.key COPYONLY)
configure_file(certs/client_CA1_2.pem client_CA1_2.pem COPYONLY)

configure_file(certs/client_CA1_3.key client_CA1_3.key COPYONLY)
configure_file(certs/client_CA1_3.pem client_CA1_3.pem COPYONLY)

configure_file(certs/client_CA1_4.key client_CA1_4.key COPYONLY)
configure_file(certs/client_CA1_4.pem client_CA1_4.pem COPYONLY)

configure_file(certs/server_CA1_1_chain.pem server_CA1_1_chain.pem)

configure_file(certs/test.crl test.crl COPYONLY)

add_executable(tests
  ${tests_SRCS}
)

target_link_libraries(tests
    lib60870
)

=== lib60870-C/examples/cs101_master_balanced/CMakeLists.txt ===
include_directories(
   .
)

set(example_SRCS
   master_example.c
)

IF(WIN32)
set_source_files_properties(${example_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF(WIN32)

add_executable(cs101_master_balanced
  ${example_SRCS}
)

target_link_libraries(cs101_master_balanced
    lib60870
)

=== lib60870-C/examples/cs101_master_balanced/Makefile ===
LIB60870_HOME=../..

PROJECT_BINARY_NAME = cs101_master
PROJECT_SOURCES = master_example.c

include $(LIB60870_HOME)/make/target_system.mk
include $(LIB60870_HOME)/make/stack_includes.mk

all:	$(PROJECT_BINARY_NAME)

include $(LIB60870_HOME)/make/common_targets.mk


$(PROJECT_BINARY_NAME):	$(PROJECT_SOURCES) $(LIB_NAME)
	$(CC) $(CFLAGS) $(LDFLAGS) -g -o $(PROJECT_BINARY_NAME) $(PROJECT_SOURCES) $(INCLUDES) $(LIB_NAME) $(LDLIBS)

clean:
	rm -f $(PROJECT_BINARY_NAME)

=== lib60870-C/examples/cs101_master_unbalanced/CMakeLists.txt ===
include_directories(
   .
)

set(example_SRCS
   master_example.c
)

IF(WIN32)
set_source_files_properties(${example_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF(WIN32)

add_executable(cs101_master_unbalanced
  ${example_SRCS}
)

target_link_libraries(cs101_master_unbalanced
    lib60870
)

=== lib60870-C/examples/cs101_slave/CMakeLists.txt ===
include_directories(
   .
)

set(example_SRCS
   slave_example.c
)

IF(WIN32)
set_source_files_properties(${example_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF(WIN32)

add_executable(cs101_slave
  ${example_SRCS}
)

target_link_libraries(cs101_slave
    lib60870
)

=== lib60870-C/examples/cs101_slave/Makefile ===
LIB60870_HOME=../..

PROJECT_BINARY_NAME = cs101_slave
PROJECT_SOURCES = slave_example.c

include $(LIB60870_HOME)/make/target_system.mk
include $(LIB60870_HOME)/make/stack_includes.mk

all:	$(PROJECT_BINARY_NAME)

include $(LIB60870_HOME)/make/common_targets.mk


$(PROJECT_BINARY_NAME):	$(PROJECT_SOURCES) $(LIB_NAME)
	$(CC) $(CFLAGS) $(LDFLAGS) -g -o $(PROJECT_BINARY_NAME) $(PROJECT_SOURCES) $(INCLUDES) $(LIB_NAME) $(LDLIBS)

clean:
	rm -f $(PROJECT_BINARY_NAME)

=== lib60870-C/examples/cs101_slave_files/CMakeLists.txt ===
include_directories(
   .
)

set(example_SRCS
   cs101_slave_files.c
)

IF(WIN32)
set_source_files_properties(${example_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF(WIN32)

add_executable(cs101_slave_files
  ${example_SRCS}
)

target_link_libraries(cs101_slave_files
    lib60870
)

=== lib60870-C/examples/cs104_client/CMakeLists.txt ===
include_directories(
   .
)

set(example_SRCS
   simple_client.c
)

IF(WIN32)
set_source_files_properties(${example_SRCS}
                                       PROPERTIES LANGUAGE CXX)
ENDIF(WIN32)

add_executable(simple_client
  ${example_SRCS}
)

target_link_libraries(simple_client
    lib60870
)

=== lib60870-C/examples/cs104_client/Makefile ===
LIB60870_HOME=../..

PROJECT_BINARY_NAME = simple_client
PROJECT_SOURCES = simple_client.c

include $(LIB60870_HOME)/make/target_system.mk
include $(LIB60870_HOME)/make/stack_includes.mk

all:	$(PROJECT_BINARY_NAME)

include $(LIB60870_HOME)/make/common_targets.mk


$(PROJECT_BINARY_NAME):	$(PROJECT_SOURCES) $(LIB_NAME)
	$(CC) $(CFLAGS) $(LDFLAGS) -g -o $(PROJECT_BINARY_NAME) $(PROJECT_SOURCES) $(INCLUDES) $(LIB_NAME) $(LDLIBS)

clean:
	rm -f $(PROJECT_BINARY_NAME)

=== debian/changelog ===
lib60870 (2.3.6-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Tue, 19 Aug 2025 14:25:01 +0800

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,10 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
+ pkgconf,
+ libmbedtls-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://www.mz-automation.de/iec60870-5-101-104-c-source-code-library/
 Vcs-Git: https://salsa.debian.org/yangfl-guest/lib60870.git

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%lib60870-$1.tar.gz%" \
   https://github.com/mz-automation/lib60870/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## lib60870 2.4.0

=== lib60870-C/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.0...3.31)
 
 # automagically detect if we should cross-compile
 if(DEFINED ENV{TOOLCHAIN})
@@ -11,8 +11,8 @@
 ENABLE_TESTING()
 
 set(LIB_VERSION_MAJOR "2")
-set(LIB_VERSION_MINOR "3")
-set(LIB_VERSION_PATCH "5")
+set(LIB_VERSION_MINOR "4")
+set(LIB_VERSION_PATCH "0")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/third_party/cmake/modules/")
 
@@ -35,15 +35,26 @@
 
 if(BUILD_HAL)
 
-if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)
-set(WITH_MBEDTLS 1)
-message("mbedtls 2.28 found")
-ELSEIF(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6)
-set(WITH_MBEDTLS3 1)
-message("mbedtls 3.6 found")
+## Detect mbedtls dependency folders. Accept folder names with patch/minor suffixes
+set(MBEDTLS_DIR "")
+file(GLOB MBEDTLS_2_28_CANDIDATES "${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28*")
+file(GLOB MBEDTLS_3_6_CANDIDATES "${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6*")
+
+if(MBEDTLS_2_28_CANDIDATES)
+	list(GET MBEDTLS_2_28_CANDIDATES 0 MBEDTLS_DIR)
+	set(WITH_MBEDTLS 1)
+	set(WITH_SEC_AUTH 1)
+	add_definitions(-DWITH_MBEDTLS=1)
+	message("mbedtls 2.28 found: ${MBEDTLS_DIR}")
+elseif(MBEDTLS_3_6_CANDIDATES)
+	list(GET MBEDTLS_3_6_CANDIDATES 0 MBEDTLS_DIR)
+	set(WITH_MBEDTLS3 1)
+	set(WITH_SEC_AUTH 1)
+	add_definitions(-DWITH_MBEDTLS3=1)
+	message("mbedtls 3.6 found: ${MBEDTLS_DIR}")
 else()
-message("NOTE: mbedtls 2.28 or 3.6 is required for TLS support!")
-endif(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)
+	message("NOTE: mbedtls 2.28 or 3.6 is required for TLS support and secure authentication!")
+endif()
 
 endif(BUILD_HAL)
 
@@ -56,31 +67,25 @@
     ${CMAKE_CURRENT_LIST_DIR}/src/hal/inc
 )
 
-if(WITH_MBEDTLS)
-include_directories(
-    ${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls
-    ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28/include
-)
+if(MBEDTLS_DIR)
+	# choose appropriate HAL adapter (mbedtls vs mbedtls3)
+	if(WITH_MBEDTLS3)
+		include_directories(
+			${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls3
+			${MBEDTLS_DIR}/include
+		)
+		file(GLOB tls_SRCS ${MBEDTLS_DIR}/library/*.c)
+	else()
+		include_directories(
+			${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls
+			${MBEDTLS_DIR}/include
+		)
+		file(GLOB tls_SRCS ${MBEDTLS_DIR}/library/*.c)
+	endif()
 
-file(GLOB tls_SRCS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28/library/*.c)
-
-add_definitions(-DCONFIG_CS104_SUPPORT_TLS=1)
-add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")
-
-endif(WITH_MBEDTLS)
-
-if(WITH_MBEDTLS3)
-include_directories(
-	${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls3
-	${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6/include
-)
-
-file(GLOB tls_SRCS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6/library/*.c)
-
-add_definitions(-DCONFIG_CS104_SUPPORT_TLS=1)
-add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")
-
-endif(WITH_MBEDTLS3)
+	add_definitions(-DCONFIG_CS104_SUPPORT_TLS=1)
+	add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")
+endif()
 
 
 set(API_HEADERS 
@@ -114,6 +119,16 @@
 # write the detected stuff to this file
 # configure_file(config/lib60870_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config/lib60870_config.h)
 
+add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/src)
+
+if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/modules/sec-auth)
+
+add_compile_definitions(SEC_AUTH_60870_5_7)
+
+include(${CMAKE_CURRENT_LIST_DIR}/modules/sec-auth/CMakeLists.txt)
+
+endif(EXISTS ${CMAKE_CURRENT_LIST_DIR}/modules/sec-auth)
+
 if(BUILD_EXAMPLES)
 	add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/examples)
 endif(BUILD_EXAMPLES)
@@ -121,8 +136,6 @@
 if(BUILD_TESTS)
 	add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/tests)
 endif(BUILD_TESTS)
-
-add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/src)
 
 INSTALL(FILES ${API_HEADERS} DESTINATION include/lib60870 COMPONENT Development)

=== lib60870-C/Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
 LIB_SOURCE_DIRS += src/hal/socket/win32
 LIB_SOURCE_DIRS += src/hal/thread/win32
 LIB_SOURCE_DIRS += src/hal/time/win32
+LIB_SOURCE_DIRS += src/hal/serial/win32
 LIB_SOURCE_DIRS += src/hal/memory
 else ifeq ($(HAL_IMPL), POSIX)
 LIB_SOURCE_DIRS += src/hal/socket/linux
@@ -34,20 +35,39 @@
 LIB_SOURCE_DIRS += src/hal/memory
 endif
 
+# Auto-detect mbedtls dependency folder if not explicitly provided.
+# Prefer mbedtls-3.6* over mbedtls-2.28*, and pick the highest patch version when multiple exist.
+# If the user sets WITH_MBEDTLS or WITH_MBEDTLS3 externally, that will be respected.
+ifeq ($(strip $(WITH_MBEDTLS)),)
+ifeq ($(strip $(WITH_MBEDTLS3)),)
+	# try mbedtls-3.6* first (only directories, exclude archives)
+	MBEDTLS_DIR := $(shell for d in $(LIB60870_HOME)/dependencies/mbedtls-3.6*; do [ -d "$$d" ] && echo "$$d"; done | sort -V | tail -n1)
+	ifeq ($(strip $(MBEDTLS_DIR)),)
+		# fallback to mbedtls-2.28* (only directories)
+		MBEDTLS_DIR := $(shell for d in $(LIB60870_HOME)/dependencies/mbedtls-2.28*; do [ -d "$$d" ] && echo "$$d"; done | sort -V | tail -n1)
+		ifneq ($(strip $(MBEDTLS_DIR)),)
+			WITH_MBEDTLS := 1
+		endif
+	else
+		WITH_MBEDTLS3 := 1
+	endif
+endif
+endif
+
 ifdef WITH_MBEDTLS
-LIB_SOURCE_DIRS += dependencies/mbedtls-2.28/library
+LIB_SOURCE_DIRS += $(MBEDTLS_DIR)/library
 LIB_SOURCE_DIRS += src/hal/tls/mbedtls
 LIB_INCLUDE_DIRS += src/hal/tls/mbedtls
-LIB_INCLUDE_DIRS += dependencies/mbedtls-2.28/include
+LIB_INCLUDE_DIRS += $(MBEDTLS_DIR)/include
 CFLAGS += -D'MBEDTLS_CONFIG_FILE="mbedtls_config.h"'
 CFLAGS += -D'CONFIG_CS104_SUPPORT_TLS=1'
 endif
 
 ifdef WITH_MBEDTLS3
-LIB_SOURCE_DIRS += dependencies/mbedtls-3.6/library
+LIB_SOURCE_DIRS += $(MBEDTLS_DIR)/library
 LIB_SOURCE_DIRS += src/hal/tls/mbedtls3
 LIB_INCLUDE_DIRS += src/hal/tls/mbedtls3
-LIB_INCLUDE_DIRS += dependencies/mbedtls-3.6/include
+LIB_INCLUDE_DIRS += $(MBEDTLS_DIR)/include
 CFLAGS += -D'MBEDTLS_CONFIG_FILE="mbedtls_config.h"'
 CFLAGS += -D'CONFIG_CS104_SUPPORT_TLS=1'
 endif

=== lib60870-C/examples/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 add_subdirectory(cs101_slave_files)
 add_subdirectory(cs104_client)
 add_subdirectory(cs104_client_async)
+add_subdirectory(cs104_client_no_threads)
 add_subdirectory(cs104_server)
 add_subdirectory(cs104_server_no_threads)
 add_subdirectory(cs104_server_files)

=== lib60870-C/src/CMakeLists.txt ===
--- 
+++ 
@@ -58,6 +58,14 @@
 )
 
 endif (BUILD_HAL)
+
+if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/../modules/sec-auth)
+
+include(${CMAKE_CURRENT_LIST_DIR}/../modules/sec-auth/CMakeLists_src.txt)
+
+add_compile_definitions(SEC_AUTH_60870_5_7)
+
+endif(EXISTS ${CMAKE_CURRENT_LIST_DIR}/../modules/sec-auth)
 
 IF(WIN32)

=== lib60870-C/tests/CMakeLists.txt ===
--- 
+++ 
@@ -38,6 +38,13 @@
 configure_file(certs/server_CA1_1_chain.pem server_CA1_1_chain.pem)
 
 configure_file(certs/test.crl test.crl COPYONLY)
+configure_file(certs/test_initial.crl test_initial.crl COPYONLY)
+
+configure_file(certs/client_CA1_badsig.key client_CA1_badsig.key COPYONLY)
+configure_file(certs/client_CA1_badsig.pem client_CA1_badsig.pem COPYONLY)
+
+configure_file(certs/client_CA1_weak.key client_CA1_weak.key COPYONLY)
+configure_file(certs/client_CA1_weak.pem client_CA1_weak.pem COPYONLY)
 
 add_executable(tests
   ${tests_SRCS}

=== lib60870-C/examples/cs104_client_no_threads/CMakeLists.txt ===
add_executable(cs104_client_no_threads cs104_client_no_threads.c)

target_link_libraries(cs104_client_no_threads PRIVATE lib60870)

=== debian/changelog ===
lib60870 (2.4.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.3

 -- Yangfl <mmyangfl@gmail.com>  Wed, 25 Feb 2026 03:20:10 +0800

lib60870 (2.3.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113105)

 -- Adrian Bunk <bunk@debian.org>  Sat, 08 Nov 2025 15:22:02 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,12 @@
 Source: lib60870
-Priority: optional
+Section: libs
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
  pkgconf,
  libmbedtls-dev,
-Rules-Requires-Root: no
-Standards-Version: 4.7.2
-Section: libs
+Standards-Version: 4.7.3
 Homepage: https://www.mz-automation.de/iec60870-5-101-104-c-source-code-library/
 Vcs-Git: https://salsa.debian.org/yangfl-guest/lib60870.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/lib60870

=== debian/watch ===
Version: 5
Template: Github
Owner: mz-automation
Project: lib60870
